Assignee:
Description

QgsProject API Documentation states:

bool     read (QFileInfo const &file)

     read project file

bool     read ()

     presuming that the caller has already reset the map canvas, map registry, and legend

the first read (QFileInfo const &file) sets the project filename and calls the second read (). As you read, it says: "presuming that the caller

has already reset the map canvas, map registry, and legend", so I wanted to use it to append my QGIS project file to current.

But it doesn't happen: current maplayers are cleared and substituted to the layers of the project file, althrough I still see the old project title

in the window titlebar.

Here's how you can reproduce it:

    1. write a plugin with this code: QgsProject.instance().read ( new QFileInfo ( "<path of a qgis file>" ) ); 

    2. open a different qgis project file

    3. launch the plugin

    4. all layers are substituted.

History

#1 - 2012-09-04 11:52 AM - Paolo Cavallini

- Target version changed from Version 1.8.0 to Version 2.0.0

#2 - 2012-09-29 08:10 AM - Sandro Santilli

I'm also looking for a way to "append" layers to an existing project. Ideally all under a group named after the file.

#3 - 2012-09-29 08:15 AM - Sandro Santilli

The code is intentionally clearing all stuff, surely for project properties but don't know if for anything else too (assets referenced by layers?):

  // before we start loading everything, let's clear out the current set of

  // properties first so that we don't have the properties from the previous

  // project still hanging around
  imp_->clear();

  mEmbeddedLayers.clear();

#4 - 2012-12-30 09:51 AM - Giovanni Manghi

- Priority changed from High to Normal

#5 - 2014-01-29 05:06 AM - luca76 -

- Target version changed from Version 2.0.0 to Future Release - Lower Priority

#6 - 2014-03-26 11:25 AM - Alexander Bruy

- Category changed from C++ Plugins to Project Loading/Saving

#7 - 2016-07-05 08:15 AM - luca76 -

- Resolution set to invalid

- Status changed from Open to Closed
